/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package main;

import java.util.ArrayList;
import javafx.application.Application;
import javafx.beans.property.SimpleStringProperty;
import javafx.beans.value.ObservableValue;
import javafx.scene.Scene;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableColumn.CellDataFeatures;
import javafx.scene.layout.Priority;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;
import javafx.util.Callback;
import javafx.scene.control.TableView;

public class Main extends Application {
    final static int ROWS_NUM = 30;
    final static int COLUMNS_NUM = 20;

    @Override
    public void start(Stage stage) {
        VBox content = new VBox();

        final TableView<Data> view = new TableView<Data>();

        for (int i = 0; i < ROWS_NUM; i++) {
            view.getItems().add(new Data(i, COLUMNS_NUM));
        }

        VBox.setVgrow(view, Priority.ALWAYS);
        for (int i = 0; i < COLUMNS_NUM; i++) {
            TableColumn<Data, String> field = new TableColumn<Data, String>("Column");
            final int _i = i;
            field.setCellValueFactory(new Callback<CellDataFeatures<Data, String>, ObservableValue<String>>() {
                public ObservableValue<String> call(CellDataFeatures<Data, String> p) {
                    return new SimpleStringProperty(p.getValue().data.get(_i));
                }
            });
            view.getColumns().add(field);
        }

        
        content.getChildren().add(view);

        Scene scene = new Scene(content, 400, 400);

        stage.setScene(scene);
        stage.show();
    }

    public static class Data {
        public ArrayList<String> data = new ArrayList<String>();
        public Data(int column_num, int fields_num) {
            for (int i = 0; i < fields_num; i++) {
                data.add("item " + column_num + " field " + i);
            }
        }
    }

    public static void main(String[] args) {
        launch(Main.class, args);
    }
}